"""Module to setup fastapi API to expose API to the outside world."""
import logging
import random
from typing import Any, Dict, List, Optional

from fastapi import FastAPI, Query
import uvicorn

ERROR_CODES = [error_code for error_code in range(50)]
LOGGER = logging.getLogger("API")
app = FastAPI()

""" declare and initialize the count variable globally to keep track that how many requests for errors are received"""
count = 0

""" decalartion of dictionary to store the count that operator request for error list against operator name"""
operator_info = {}


"""" ####################################################################################################### """
"""" ##################################_api version one (backend)_########################################## """
"""" ####################################################################################################### """


def _generate_lists() -> Dict[str, Any]:
    """Generate resolved, unresolved and backlog lists."""
    return {
        'resolved': [{
            'index': error_idx,
            'code': random.choice(ERROR_CODES),
            'text': 'Error ABC occured, that is `resolved`'
        } for error_idx in range(50)],
        'unresolved': [{
            'index': error_idx,
            'code': random.choice(ERROR_CODES),
            'text': 'Error DEF occured, that is `unresolved`'
        } for error_idx in range(50, 100)],
        'backlog': [{
            'index': error_idx,
            'code': random.choice(ERROR_CODES),
            'text': 'Error XYZ occured, that is in the `backlog`'
        } for error_idx in range(100, 150)]
    }


@app.get("/get_lists")
def get_lists() -> Dict[str, Any]:
    """Return resolved, unresolved and backlog lists."""
    LOGGER.info('Generating resolved, unresolved and backlog lists.')
    return _generate_lists()


### write a logging functionality, that counts how many requests for errors are received ###
@app.get("/count_of_error")
def count_of_error() -> int:
    """Return counts of how many requests for errors are received"""
    LOGGER.info(
        'Increment the count that how many requests for errors are received.')
    global count
    count = count + 1
    print("The number of request received for errors are", count)
    return count


def replace(l, element):
    """
    # replace function that is used for CASE - 2 
    # replace the element in the list with -1 integer
    # assumption is that the error code must be either zero or positive number 
    """
    for i in range(0, len(l)):
        if l[i] == element:
            l[i] = -1


### implement the code of the `get_list_intersection_counts` function endpoint ###
@app.get("/get_list_intersection_counts")
def get_list_intersection_counts() -> Dict[str, int]:
    """Return the error intersection counts between a set of resolved, unresolved and backlog lists.

    Returns
    -------
    intersection_counts: Dict[str, int]
        The intersection counts between resolved, unresolved and backlog lists, e.g.:
        ```json
        {
            "resolved_unresolved": 12,
            "resolved_backlog": 6,
            "unresolved_backlog": 35
        }
        ```
        `"resolved_unresolved": 12` describes that there are `12` errors with the *same error code*  shared
        between a `resolved` and `unresolved` list, `"resolved_backlog": 6` describes that there are `6`
        errors with the *same error code*  shared between a `resolved` and `backlog` list.

        The three lists required for this calculation are generated by calling `_generate_lists`.

        Code that checks whether errors from the resolved and unresolved list `intersect`, could look like:
        ```python
        error_lists = _generate_lists()
        resolved, unresolved, backlog = error_lists['resolved'], error_lists['unresolved'], error_lists['backlog']

        error_from_resolved = resolved[0]
        error_from_unresolved  = unresolved[0]
        if error_from_resolved.code == error_from_unresolved.code:
            print('Errors intersect')
        else:
            print('Errors do not intersect')
        ```

    """
    LOGGER.info(
        'Generating the intersection counts between a set of resolved, unresolved and backlog lists.')

    error_lists = _generate_lists()
    resolved, unresolved, backlog = error_lists['resolved'], error_lists['unresolved'], error_lists['backlog']

    # TODO: Implement the code that calculates how many errors with *the same error code* are shared between
    # the possible pairs of lists here. Then return a Dict like the one shown in the documentation string above,
    # e.g.:

    #########################################################################################################
    ############################################### CONFUSION ###############################################
    #########################################################################################################
    # the error code are generated with RANDOM function in '_generate_lists'
    # so due to random function, there is a probability that a single category of error type may have more than
    # one same error code
    # e.g.:

    """
    >>> resolved_code = [5,2,5,3,6]
    >>> unresolved_code = [5,5,3,1,0]
    """

    # CONFUSION POINT FOR ME :
    # according to the SET theory of    ------------------------>>>> CASE - 1
    # mathematics the intersection should be [5,3]

    # but common error code are [5,5,3] ------------------------>>>> CASE - 2
    # (same error code)

    # HERE : is some confusion between intersection & same error code (that is mentioned in the task)

    #########################################################################################################
    ########################################## INITIALIZATION BLOCK #########################################
    #########################################################################################################

    # initialize the below three list to store the error code
    resolved_code = []
    unresolved_code = []
    backlog_code = []

    # declare & initialize the variable to keep track of count of intersection between combinations
    resolved_unresolved = 0
    resolved_backlog = 0
    unresolved_backlog = 0

    # extract only the error code of resolved, unresolved and backlog and append in separate list to
    # perform the intersection operation
    for i in range(0, len(resolved)):
        resolved_code.append(resolved[i]['code'])
        unresolved_code.append(unresolved[i]['code'])
        backlog_code.append(backlog[i]['code'])
        
    
    #########################################################################################################
    ############################################### CASE - 1 ################################################
    #########################################################################################################
    # Intersection: the intersection of the two error category should be only the unique error code
    # the first optimal logic that I used thought is to perform the AND '&' operator
    # between two set which return the common elements in both set and
    # return the length of resultant set that tells how many common errors in both category
    # e.g.:

    # resolved_unresolved = len(set(resolved_code) & set(unresolved_code))
    # resolved_backlog = len(set(resolved_code) & set(backlog_code))
    # unresolved_backlog = len(set(unresolved_code) & set(backlog_code))

    # print("--------INTERSECTION-------")
    # print("resolved_unresolved:", resolved_unresolved, "resolved_backlog:",
    #       resolved_backlog, "unresolved_backlog:", unresolved_backlog)
    #########################################################################################################
    ############################################### CASE - 2 ################################################
    #########################################################################################################
    # common error code are [5,5,3] (referred to above example)
    # Thats why I mentioned and explained the implementation of this scenario in detail
    # If you though that the intersection in this scenario is the same error code regardless of the
    # DISTINCT error code
    # then comment out the below code, it works fine !

    
    # comparsion of resolved error code with unresolved code & backlog code
    for i in range(0,len(resolved)):
        # assumption is that error code is greater than or equal to zero
        # as random function in '_generate_lists' assign the error code between 0 to 50

        if resolved_code[i] > -1:
            # comparsion between resolved_code & unresolved_code
            # the count of specific error code in resolved_code is more than the unresolved_code
            # then count should of resolved_unresolved is incremented by the minimum count of both error category
            # which is unresolved_code count
            # otherwise : resolved_code is added in counter value either of equal or lesser condition

            if resolved_code.count(resolved_code[i]) > unresolved_code.count(resolved_code[i]):
                resolved_unresolved = resolved_unresolved + unresolved_code.count(resolved_code[i])
            else:
                resolved_unresolved = resolved_unresolved + resolved_code.count(resolved_code[i])
                
            if :   
            resolved_unresolved = resolved_code.count(resolved_code[i]) + unresolved_code.count(resolved_code[i])    

            # comparsion between resolved_code & backlog_code
            # same logic as above

            if resolved_code.count(resolved_code[i]) > backlog_code.count(resolved_code[i]):
                resolved_backlog = resolved_backlog + backlog_code.count(resolved_code[i])
            else:
                resolved_backlog = resolved_backlog + resolved_code.count(resolved_code[i])

            # Replace the resolved error code with -1 so it should not be counted again in next iterations
            replace(resolved_code, resolved_code[i])


    # comparsion of unresolved error code with backlog code

    for i in range(0,len(unresolved_code)):
        if unresolved_code[i] > -1:
            if unresolved_code.count(unresolved_code[i]) > backlog_code.count(unresolved_code[i]):
                unresolved_backlog = unresolved_backlog + backlog_code.count(unresolved_code[i])
            else:
                unresolved_backlog = unresolved_backlog + unresolved_code.count(unresolved_code[i])

            replace(unresolved_code, unresolved_code[i])

    

    # Return the intersection either by CASE-1 logic or CASE-2
    # I preferred here CASE-1 !
    return {
        'resolved_unresolved': resolved_unresolved,
        'resolved_backlog': resolved_backlog,
        'unresolved_backlog': unresolved_backlog
    }


"""" ####################################################################################################### """
"""" #######################################_api version two_############################################### """
"""" ####################################################################################################### """


@app.get("/operator_requested_data/{operator_name}")
def operator_requested_data(operator_name: str) -> int:
    """Return count of error that is requested by operator."""
    LOGGER.info("Operator Requested for error list")

    # check if the operator is already there
    # then simply increment its count
    # which mean he/she request the data again
    # Otherwise: the operator is new
    # so assign the counter value 1 which mean it request the error data first time
    if operator_name in operator_info.keys():
        operator_info[operator_name] = operator_info[operator_name] + 1
    else:
        operator_info[operator_name] = 1

    # print the log on command terminal that how many times the specific user requested for data
    print("Operator", operator_name, "is requested for",
          operator_info[operator_name], "times error data ....")

    return operator_info[operator_name]


@app.get("/error_code_marked_resolved/{operator_name}/")
def error_code_marked_resolved(operator_name: str, error_code_list: list = Query([])):
    """Return count of error that is requested by operator."""

    # error_code_list: the operator can send all errors that are currently marked as `resolved` to the `api`
    # operator_name: who send the all error codes to api

    LOGGER.info("List of error code marked as resolved")

    for error_code in set(error_code_list):
        # prints out how many times a certain `error.code` was resolved
        # print the log on command terminal that how many times the specific error code is marked as resolved
        print("Operator", operator_name, "resolved error code",
              error_code, "by", error_code_list.count(error_code), "times")


def run(host: str, port: int) -> None:
    """Run the code challenge API."""
    uvicorn.run(app, host=host, port=port)
